#include <Wire.h>
#include <hd44780.h>
#include <hd44780ioClass/hd44780_I2Cexp.h>

hd44780_I2Cexp lcd;

int Vo = A0,  V_LED = 2;
int cnt = 0;

float Vo_value = 0.0, Voltage = 0.0;
float dustDensity = 0.0, sumDustDensity = 0.0;
float avg;

void setup() {
  Serial.begin(9600);
  lcd.begin (16, 2);
  pinMode(V_LED, OUTPUT);
}

void loop() {
  digitalWrite(V_LED, LOW);
  delayMicroseconds(280);
  Vo_value = analogRead(Vo);
  delayMicroseconds(40);
  digitalWrite(V_LED, HIGH);
  delayMicroseconds(9680);

  Voltage = Vo_value * 5.0 / 1023.0;
  dustDensity = (Voltage - 0.3) / 0.005;
  cnt++;
  if(cnt == 60){
    sumDustDensity = avg;
    cnt = 2;
  }
  sumDustDensity += dustDensity;
  avg = sumDustDensity / cnt;
  
  lcd.clear();
  lcd.setCursor (0,0);
  lcd.print("Dust : ");
  if(avg < 0){
    avg = 0;
  }
  lcd.print(avg, 2);
  lcd.setCursor (0,1);
  lcd.print("Have a nice day!");
  
  delay(5000);
}
